$.ui.igGridFiltering.prototype._getFilterEditorOptionsByKey = function (key) {
	var i, settings = this.options.columnSettings;
	for(i = 0; i < settings.length; i++) {
		if (settings[i].columnKey == key)
			return settings[i].filterEditorOptions;
	}
};
$.ui.igGridFiltering.prototype._getFilterEditorByKey = function (key) {
	var i, settings = this.options.columnSettings;
	for(i = 0; i < settings.length; i++) {
		if (settings[i].columnKey == key)
			return settings[i].filterEditor;
	}
};
$.ui.igGridFiltering.prototype._populateFilterDialogInput = function (input, type, defaultValue) {
	var parent = input.parent();
	parent.empty();
	input = $("<input/>");
	parent.append(input);
	var colKey = $(input).closest("tr").find("td > span > input").igEditor("value");
	var editorType = this._getFilterEditorByKey(colKey);
	if (editorType == "combo")
	{
		var condition = $(input).closest("tr").find('td:eq(1)>select')[0].value, i, comboValues = [], expr;
		this._currentAdvancedExpressions = this._currentAdvancedExpressions || [];
		for(i = 0; i < this._currentAdvancedExpressions.length; i++) {
			expr = this._currentAdvancedExpressions[i];
			if (expr.cond == condition && expr.fieldName == colKey)
				comboValues.push(expr.expr);
		}
		var filterEditorOptions = this._getFilterEditorOptionsByKey(colKey);
		
		var tbody = parent.parent().parent();
		if (tbody.find('.' + colKey + 'Multi').length > 0 && defaultValue != undefined) {
			parent.parent().remove();
			return;

		}

		if (filterEditorOptions.multiSelection == "onWithCheckboxes" ) {
			input.addClass(colKey + "Multi" );
		}

		isAddClicked = false;
		input.igCombo(filterEditorOptions);
		input.igCombo("values", comboValues);
	}
	else {
		var options = {
			type: this._getEditorType(type),
			buttonHidden: type !== 'date',
			button: 'dropdown',
			disabled: type === 'bool',
			maxDecimals: 12,
			textAlign: (type === 'number') ? 'right' : 'left',
			width: this.options.filterDialogExprInputDefaultWidth,
			value: defaultValue,
			//_utc: true
			enableUTCDates: this.grid.options.enableUTCDates
		};
		// do not allow to create same igEditor for different elements. First time it is INPUT, but later it can be SPAN or INPUT
		if (!input.is('input')) {
			input = input.find('INPUT');
		}
		input.igEditor(options);
	}
};

$.ui.igGridFiltering.prototype._searchFilterDialog = function(e, expression) { 
	var expressions = [], rows, boolLogic, selectLogic, noCancel = true, i, j, type, expr, noCancelFiltering = true, $input, comboValues;
	noCancel = this._trigger(this.events.filterDialogFiltering, null, {dialog: $('#' + this.grid.container().attr('id') + '_dialog'), owner: this});

	if (noCancel) {
		// construct filter expressions from table
		rows = $('#' + this.grid.container().attr('id') + '_dialog table tbody').children();
		boolLogic = "and";
		selectLogic = $('#' + this.grid.container().attr('id') + '_dialog select:first');
		if (selectLogic.length > 0) {
			boolLogic = $('#' + this.grid.container().attr('id') + '_dialog select:first')[0].value === "all" ? "AND" : "OR";
		}
		for (i = 0; i < rows.length; i++) {
			type = this.grid.columnByText($(rows[i].cells[0]).find('input')[0].value).dataType; // get the column type
			$input = $(rows[i].cells[2]).find('input');
			// handle igCombo data
			if ($input.data("igCombo")) {
				boolLogic = "OR";
				comboValues = $input.igCombo("values");
				for (j = 0; j < comboValues.length; j++) {
					expr = comboValues[j];
					if ($.type(expr) === 'date' && this.grid.options.enableUTCDates) {
						expr = Date.UTC(expr.getUTCFullYear(), expr.getUTCMonth(), expr.getUTCDate(), expr.getUTCHours(), expr.getUTCMinutes());
					}
					expressions.push({
						// fire user-defined function to extract expression from row
						fieldName: this.grid.columnByText($(rows[i].cells[0]).find('input')[0].value).key,
						cond: $(rows[i].cells[1]).find('select')[0].value,
						expr: expr,
						logic: boolLogic,
						type: type
					});
				}
			} else {
				// handle igEditor data
				expr = $input.igEditor('value');
				if (expr && (expr.nodeName || (expr[0] && expr[0].nodeName))) {
					expr = $(rows[i].cells[2]).find('span').igEditor('value');
				}
				if ($.type(expr) === 'date' && this.grid.options.enableUTCDates) {
					expr = Date.UTC(expr.getUTCFullYear(), expr.getUTCMonth(), expr.getUTCDate(), expr.getUTCHours(), expr.getUTCMinutes());
				}
				expressions.push({
					// fire user-defined function to extract expression from row
					fieldName: this.grid.columnByText($(rows[i].cells[0]).find('input')[0].value).key,
					cond: $(rows[i].cells[1]).find('select')[0].value,
					expr: expr,
					logic: boolLogic,
					type: type
				});
			}
		}
		this._closeFilterDialog(e);
		this._currentAdvancedExpressions = expressions;
		// there are no column key / index here, because advanced filtering may include many colum filters, it doesn't have to be just one. 
		noCancelFiltering = this._trigger(this.events.dataFiltering, null, {owner: this});
		if (noCancelFiltering) {
			this.filter(expressions, true, true); // the third parameter denotes that those filters have been added from the advanced window 
		}
	}
	e.preventDefault();
	e.stopPropagation();
};